diff --git a/mof/LMI_Storage-Filesystem.mof b/mof/LMI_Storage-Filesystem.mof
index 546c5f8..76af9a5 100644
--- a/mof/LMI_Storage-Filesystem.mof
+++ b/mof/LMI_Storage-Filesystem.mof
@@ -65,11 +65,11 @@ class LMI_FileSystemCapabilities : CIM_FileSystemCapabilities
     [ Override("ActualFileSystemType"), Implemented(true),
       ValueMap{"0", "2", "3", "4", "5", "6", "7", "8", "9", "10",
           "11", "12", "13", "..",
-          "32769", "32770", "32771", "32772", "32773" },
+          "32769", "32770", "32771", "32772", "32773", "32774" },
       Values { "Unknown", "UFS", "HFS", "FAT", "FAT16", "FAT32",
           "NTFS4", "NTFS5", "XFS", "AFS", "EXT2", "EXT3",
           "REISERFS", "DMTF Reserved",
-          "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT"}]
+          "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT", "SWAP"}]
     uint16 ActualFileSystemType;
 
     [ Implemented(true) ] uint16 SupportedPersistenceTypes[];
@@ -100,11 +100,11 @@ class LMI_FileSystemConfigurationCapabilities : CIM_FileSystemConfigurationCapab
     [ Override("SupportedActualFileSystemTypes"), Implemented(true),
       ValueMap{"0", "2", "3", "4", "5", "6", "7", "8", "9", "10",
           "11", "12", "13", "..",
-          "32769", "32770", "32771", "32772", "32773" },
+          "32769", "32770", "32771", "32772", "32773", "32774" },
       Values { "Unknown", "UFS", "HFS", "FAT", "FAT16", "FAT32",
           "NTFS4", "NTFS5", "XFS", "AFS", "EXT2", "EXT3",
           "REISERFS", "DMTF Reserved",
-          "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT"}]
+          "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT", "SWAP"}]
     uint16 SupportedActualFileSystemTypes[];
 
 
@@ -139,11 +139,11 @@ class LMI_FileSystemSetting : CIM_FileSystemSetting
     [ Override("ActualFileSystemType"), Implemented(true),
       ValueMap{"0", "2", "3", "4", "5", "6", "7", "8", "9", "10",
           "11", "12", "13", "..",
-          "32769", "32770", "32771", "32772", "32773" },
+          "32769", "32770", "32771", "32772", "32773", "32774" },
       Values { "Unknown", "UFS", "HFS", "FAT", "FAT16", "FAT32",
           "NTFS4", "NTFS5", "XFS", "AFS", "EXT2", "EXT3",
           "REISERFS", "DMTF Reserved",
-          "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT"}]
+          "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT", "SWAP"}]
     uint16 ActualFileSystemType;
 
     [ Implemented(true) ] uint16 DataExtentsSharing;
@@ -206,11 +206,11 @@ class LMI_FileSystemConfigurationService : CIM_FileSystemConfigurationService
              "NULL."),
            ValueMap{"0", "2", "3", "4", "5", "6", "7", "8", "9", "10",
                  "11", "12", "13", "..",
-                 "32769", "32770", "32771", "32772", "32773" },
+                 "32769", "32770", "32771", "32772", "32773", "32774" },
            Values { "Unknown", "UFS", "HFS", "FAT", "FAT16", "FAT32",
                  "NTFS4", "NTFS5", "XFS", "AFS", "EXT2", "EXT3",
                  "REISERFS", "DMTF Reserved",
-                 "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT"}]
+                 "EXT4", "BTRFS", "JFS", "TMPFS", "VFAT", "SWAP"}]
       uint16 FileSystemType,
          [IN, Description (
              "Label of the filesystem being "
diff --git a/src/lmi/storage/LMI_FileSystemCapabilities.py b/src/lmi/storage/LMI_FileSystemCapabilities.py
index 23d2692..e2bd1a8 100644
--- a/src/lmi/storage/LMI_FileSystemCapabilities.py
+++ b/src/lmi/storage/LMI_FileSystemCapabilities.py
@@ -152,6 +152,7 @@ class LMI_FileSystemCapabilities(CapabilitiesProvider):
             JFS = pywbem.Uint16(32771)
             TMPFS = pywbem.Uint16(32772)
             VFAT = pywbem.Uint16(32773)
+            SWAP = pywbem.Uint16(32774)
 
         class SupportedPersistenceTypes(object):
             Other = pywbem.Uint16(1)
diff --git a/src/lmi/storage/LMI_FileSystemConfigurationCapabilities.py b/src/lmi/storage/LMI_FileSystemConfigurationCapabilities.py
index 8587725..52004c1 100644
--- a/src/lmi/storage/LMI_FileSystemConfigurationCapabilities.py
+++ b/src/lmi/storage/LMI_FileSystemConfigurationCapabilities.py
@@ -98,6 +98,7 @@ class LMI_FileSystemConfigurationCapabilities(CapabilitiesProvider):
             JFS = pywbem.Uint16(0x8003)
             TMPFS = pywbem.Uint16(0x8004)
             VFAT = pywbem.Uint16(0x8005)
+            SWAP = pywbem.Uint16(0x8006)
 
         class SupportedAsynchronousMethods(object):
             CreateFileSystem = pywbem.Uint16(2)
diff --git a/src/lmi/storage/LMI_FileSystemConfigurationService.py b/src/lmi/storage/LMI_FileSystemConfigurationService.py
index c38d917..53fe9a0 100644
--- a/src/lmi/storage/LMI_FileSystemConfigurationService.py
+++ b/src/lmi/storage/LMI_FileSystemConfigurationService.py
@@ -189,7 +189,9 @@ class LMI_FileSystemConfigurationService(ServiceProvider):
                 types.EXT3: 'ext3',
                 types.EXT4: 'ext4',
                 types.BTRFS: 'btrfs',
-                types.VFAT: 'vfat'
+                types.VFAT: 'vfat',
+                types.REISERFS: 'reiserfs',
+                types.SWAP: 'swap'
         }
         fsname = fstypes.get(param_filesystemtype, 'None')
         if not fsname:
@@ -507,6 +509,7 @@ class LMI_FileSystemConfigurationService(ServiceProvider):
                 JFS = pywbem.Uint16(32771)
                 TMPFS = pywbem.Uint16(32772)
                 VFAT = pywbem.Uint16(32773)
+                SWAP = pywbem.Uint16(32774)
         class DeleteFileSystem(object):
             Job_Completed_with_No_Error = pywbem.Uint32(0)
             Not_Supported = pywbem.Uint32(1)
diff --git a/src/lmi/storage/LocalFileSystemProvider.py b/src/lmi/storage/LocalFileSystemProvider.py
index daf74e9..7a87871 100644
--- a/src/lmi/storage/LocalFileSystemProvider.py
+++ b/src/lmi/storage/LocalFileSystemProvider.py
@@ -506,6 +506,7 @@ class LocalFileSystemProvider(FormatProvider, SettingHelper):
             JFS = pywbem.Uint16(0x8003)
             TMPFS = pywbem.Uint16(0x8004)
             VFAT = pywbem.Uint16(0x8005)
+            SWAP = pywbem.Uint16(0x8006)
 
         class FilenameCaseAttributes(object):
             Unknown = pywbem.Uint16(0)